summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorWilliam R. Fraser <wfraser@codewise.org>2016-03-20 17:44:09 -0700
committerPádraig Brady <P@draigBrady.com>2016-12-19 20:13:51 +0000
commit9944e4763bb178852727812e8b188540772384e2 (patch)
tree02803ee9f30391c6c9c1520fd61fe7f57099af95 /tests
parentf071b04afaeefbf6c37a00986fec02b8df5e9560 (diff)
downloadcoreutils-9944e4763bb178852727812e8b188540772384e2.tar.xz
wc: fix wrong byte counts when using --files-from0
* src/wc.c (main): Reset fstatus[0].failed between files when reusing the fstatus[0] entry in --files-from0 mode. This ensures a stat() is done for each file, avoiding incorrect counts and redundant reading. * NEWS: Mention the bug fix. * tests/misc/wc-files0.sh: Add a test case. Fixes http://bugs.gnu.org/23073
Diffstat (limited to 'tests')
-rwxr-xr-xtests/misc/wc-files0.sh13
1 files changed, 12 insertions, 1 deletions
diff --git a/tests/misc/wc-files0.sh b/tests/misc/wc-files0.sh
index 12b7d6afe..d92a01032 100755
--- a/tests/misc/wc-files0.sh
+++ b/tests/misc/wc-files0.sh
@@ -25,7 +25,7 @@ printf '2b\n2w\n' |tr '\n' '\0' > names || framework_failure_
wc --files0-from=names > out || fail=1
-cat <<\EOF > exp || fail=1
+cat <<\EOF > exp || framework_failure_
1 1 2 2b
1 2 8 2w
2 3 10 total
@@ -48,4 +48,15 @@ printf '%s\0' "$nlname" | wc --files0-from=- > out || fail=1
printf '%s\n' "0 0 0 '1'$'\\n''2'" > exp || framework_failure_
compare exp out || fail=1
+# Ensure correct byte counts, which fails between v7.1 and v8.26 inclusive
+truncate -s1G wc.big || framework_failure_
+touch wc.small || framework_failure_
+printf '%s\0' wc.big wc.small | wc -c --files0-from=- >out || fail=1
+cat <<\EOF > exp || framework_failure_
+1073741824 wc.big
+0 wc.small
+1073741824 total
+EOF
+compare exp out || fail=1
+
Exit $fail